use crate::model::notification::Notification;
use bambangshop::REQWEST_CLIENT;
use rocket::log;
use rocket::serde::json::to_string;
use rocket::serde::{Deserialize, Serialize};
use rocket::tokio;

#[derive(Debug, Clone, Deserialize, Serialize)]
#[serde(crate = "rocket::serde")]
pub struct Subscriber {
    pub url: String,
    pub name: String,
}

impl Subscriber {
    #[tokio::main]
    pub async fn update(&self, payload: Notification) {
        REQWEST_CLIENT
            .post(&self.url)
            .header("Content-Type", "JSON")
            .body(to_string(&payload).unwrap())
            .send()
            .await
            .ok();
        log::warn_!(
            "Sent {} notification of : [{}] {}, to P{}",
            payload.status,
            payload.product_type,
            payload.product_title,
            self.url
        )
    }
}
